//+------------------------------------------------------------------
//|                                                      LabTrend.mq4 
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_color5  LimeGreen
#property indicator_color6  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern double          Risk            = 1;
extern bool            alertsOn        = false;    // Turn alerts on
extern bool            alertsOnCurrent = true;     // Alerts on currnt (still opened) bar
extern bool            alertsMessage   = true;     // Aleert should show pop-up message
extern bool            alertsSound     = false;    // Alerts should play alert sound
extern bool            alertsPushNotif = false;    // Alerts should send push notification
extern bool            alertsEmail     = false;    // Alerts should send email

extern bool            ShowCandles     = true;
extern bool            ShowSignals     = true;
extern bool            SignalsOnFirst  = false;

//
//
//
//
//

double wicUp[];
double wicDn[];
double barUp[];
double barDn[];
double arrUp[];
double arrDn[];
double trend[];
double trens[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);  
      SetIndexBuffer(0, wicUp); 
      SetIndexBuffer(1, wicDn); 
      SetIndexBuffer(2, barUp); 
      SetIndexBuffer(3, barDn); 
      SetIndexBuffer(4, arrUp); SetIndexArrow(4,108);
      SetIndexBuffer(5, arrDn); SetIndexArrow(5,108);
      SetIndexBuffer(6, trend); 
      SetIndexBuffer(7, trens); 
   
      //
      //
      //
      //
      //
      
      if (ShowCandles)
            { SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexStyle(3,DRAW_HISTOGRAM); }
      else  { SetIndexStyle(0,DRAW_NONE);      SetIndexStyle(1,DRAW_NONE);      SetIndexStyle(2,DRAW_NONE);      SetIndexStyle(3,DRAW_NONE);  }
      if (ShowSignals)
            { SetIndexStyle(4,DRAW_ARROW); SetIndexStyle(5,DRAW_ARROW); }
      else  { SetIndexStyle(4,DRAW_NONE);  SetIndexStyle(5,DRAW_NONE);  }

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted(),length = 3+2*Risk;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
       if (returnBars) { wicUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      for (i = limit; i >= 0 ; i--)
      {
         
          double smin  =  Low[iLowest(NULL,0, MODE_LOW, length,i)];         
          double smax  = High[iHighest(NULL,0,MODE_HIGH,length,i)];  
          double bsmax = smax-(smax-smin)*(33.0-Risk)/100.0;	
          double bsmin = smin+(smax-smin)*(33.0-Risk)/100.0;
          trend[i] = trend[i+1];
          trens[i] = trens[i+1];

               if (Close[i] > bsmax) { trend[i] =  1; trens[i] =  1; }
               if (Close[i] < bsmin) { trend[i] = -1; trens[i] = -1; } 
                                    
         //
         //
         //
         //
         //
   
            wicUp[i] = EMPTY_VALUE;
            wicDn[i] = EMPTY_VALUE;
            barUp[i] = EMPTY_VALUE;
            barDn[i] = EMPTY_VALUE;
            arrUp[i] = EMPTY_VALUE;
            arrDn[i] = EMPTY_VALUE;

            if (trend[i] ==  1) 
            { 
              wicUp[i] = High[i]; wicDn[i] = Low[i]; 
              barUp[i] = MathMax(Open[i],Close[i]);
              barDn[i] = MathMin(Open[i],Close[i]); 
            }
            if (trend[i] == -1) 
            {
              wicUp[i] = Low[i];  wicDn[i] = High[i]; 
              barUp[i] = MathMin(Open[i],Close[i]);
              barDn[i] = MathMax(Open[i],Close[i]);
            }
            if (trens[i] != trens[i+1])
            {
              if (trens[i] ==  1) arrUp[i] = Low[i] -0.5*iATR(NULL,0,10,i);
              if (trens[i] == -1) arrDn[i] = High[i]+0.5*iATR(NULL,0,10,i);
            }
      }
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         wicUp[i] = EMPTY_VALUE;
         wicDn[i] = EMPTY_VALUE;
         barUp[i] = EMPTY_VALUE;
         barDn[i] = EMPTY_VALUE;
         arrUp[i] = EMPTY_VALUE;
         arrDn[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Risk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,6,y);
         trens[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Risk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,7,y);

         //
         //
         //
         //
         //
            
         if (trend[i] ==  1) 
         { 
           wicUp[i] = High[i]; wicDn[i] = Low[i]; 
           barUp[i] = MathMax(Open[i],Close[i]);
           barDn[i] = MathMin(Open[i],Close[i]); 
         }
         if (trend[i] == -1) 
         {
           wicUp[i] = Low[i];  wicDn[i] = High[i]; 
           barUp[i] = MathMin(Open[i],Close[i]);
           barDn[i] = MathMax(Open[i],Close[i]);
         }
         if (trens[i] != trens[i+1])
         {
           if (trens[i] ==  1) arrUp[i] = Low[i] -0.5*iATR(NULL,0,10,i);
           if (trens[i] == -1) arrDn[i] = High[i]+0.5*iATR(NULL,0,10,i);
         }
   }
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trens[whichBar] != trens[whichBar+1])
      {
         if (trens[whichBar] ==  1) doAlert(whichBar,"up");
         if (trens[whichBar] == -1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," LabTrend changed to ",doWhat);
          if (alertsMessage)    Alert(message);
          if (alertsEmail)      SendMail(StringConcatenate(Symbol(),"LabTrend"),message);
          if (alertsPushNotif)  SendNotification(message);
          if (alertsSound)      PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
